/* ploticus data display engine.  Software, documentation, and examples.  
 * Copyright 1998-2001 Stephen C. Grubb  (steve@sgpr.net).
 * Covered by GPL; see the file ./Copyright for details. */


/* routines related to categories.. */
/* scg 12/6/00 - vectorized curcat
   scg 12/6/00 - added addcat and dont_init_ncats
 */
#include "pl.x"

static int curcat[2] = { 0, 0 };
static int dont_init_ncats[2] = { 0, 0 };

/* --------------------------------------------- */
/* SETCATS - fill categories list */
setcats( ax, bigbuf )
char ax;
char *bigbuf;
{
int df;
int axsel, textloc;
int i, j;
char buf[200];
char fname[50];

if( ax == 'x' ) axsel = 0;
else axsel = 1;


if( strnicmp( bigbuf, "datafield", 9 )==0 ) {  /* fill cats list from a data field.. */

        for( j = 0; j < strlen( bigbuf ); j++ ) /* allow = and , */
                                if( Emember( bigbuf[j], "=" )) bigbuf[j] = ' ';
	
	if( Nrecords[Dsel] < 1 ) Eerr( 3895, "No data for xcategories", bigbuf );
	else	{
		sscanf( bigbuf, "%*s %s", fname );
		df = fref( fname );
		if( !dont_init_ncats[axsel] ) Ncats[axsel] = 0;

		for( i = 0; i < Nrecords[Dsel]; i++ ) {
			strcpy( buf, da( i, df-1 ) );
			/* first make sure we don't have it already.. */
			for( j = 0; j < Ncats[axsel]; j++ ) {
				if( stricmp( Cats[axsel][j], buf ) ==0 ) break;
				}
			if( j == Ncats[axsel] ) { /* only add it if not yet seen.. */
				strncpy( Cats[axsel][Ncats[axsel]], buf, MAXCATLEN-1 );
				Cats[axsel][Ncats[axsel]][MAXCATLEN] = '\0';
				Ncats[axsel]++;
				}
			}
		}
	}

else	{		/* fill cats list from literal text chunk.. */
	if( !dont_init_ncats[axsel] ) Ncats[axsel] = 0;
	textloc = 0;
	while( 1 ) {
		if( textloc >= strlen( bigbuf ) ) break;
		Egetseg( buf, bigbuf, &textloc, "\n" );
		strncpy( Cats[axsel][Ncats[axsel]], buf, MAXCATLEN-1 );
		Cats[axsel][Ncats[axsel]][MAXCATLEN] = '\0';
		Ncats[axsel]++;
		}
	}
dont_init_ncats[axsel] = 0; /* for future go-rounds */
curcat[axsel] = 0;
return( 0 );
}

/* --------------------------------------------- */
/* ADDCAT - prepend or append a category to the cat list */
/*          If prepend, this must be called before main cats list is set up */
addcat( ax, pos, name )
char ax;  	/* 'x' or 'y' */
char *pos;	/* "pre" or "post" */
char *name;	/* category name */
{
int axsel;

if( ax == 'x' ) axsel = 0;
else axsel = 1;

if( strcmp( pos, "pre" )==0 ) {
	if( ! dont_init_ncats[axsel] ) Ncats[axsel] = 0;
	dont_init_ncats[axsel] = 1;
	}
if( strcmp( pos, "post" )==0 ) dont_init_ncats[axsel] = 0;
strncpy( Cats[axsel][Ncats[axsel]], name, MAXCATLEN-1 );
Cats[axsel][Ncats[axsel]][MAXCATLEN] = '\0';
Ncats[axsel]++;
return( 0 );
}



/* --------------------------------------------- */
/* NEXTCAT - for getting categories sequentially.. get next category in list.
      curcat var maintains current position. */
nextcat( ax, result, maxlen )
char ax;
char *result;
int maxlen;
{
int axsel;
if( ax == 'x' ) axsel = 0;
else axsel = 1;

if( curcat[axsel] >= Ncats[axsel] ) {
	strcpy( result, "" );
	return( 0 );
	}
strncpy( result, Cats[axsel][ curcat[axsel] ], maxlen );
result[maxlen] = '\0';
curcat[axsel]++;
return( 0 );
}
