/* ploticus data display engine.  Software, documentation, and examples.  
 * Copyright 1998-2001 Stephen C. Grubb  (steve@sgpr.net).
 * Covered by GPL; see the file ./Copyright for details. */


/* application must provide these stubs: */
#include <stdio.h>

custom_errorhandler( line )
char *line;
{
return( 0 );
}

/* returns 0 on success, -1 if named function not found */
custom_function( name, parms, value )
char *name, *parms, *value;
{ 
int i;
char val[100], axis[80], low[80], hi[80];
double flow, fhi, fval;
char c;
double Econv(), Elimit();
char buf[100];


/* $inrange(value,axis) or $inrange(value,axis,min,max)
   return 1 if value in range for the axis, 0 if not.
   min and max are optional args */
if( strcmp( name, "$inrange" )==0 ) {
	i = 0;
	Egetchunk( val, parms, &i, "," );
	Egetchunk( axis, parms, &i, "," );
	c = tolower(axis[0]);
	Egetchunk( low, parms, &i, "," );
	Egetchunk( hi, parms, &i, "," );
	fval = Econv( c, val );
	if( strlen( low ) > 0 ) flow = Econv( c, low );
	else flow = Elimit( c, 'l', 's' );
	if( strlen( hi ) > 0 ) fhi = Econv( c, hi );
	else fhi = Elimit( c, 'h', 's' );
	if( fval >= flow && fval <= fhi ) sprintf( value, "1" );
	else sprintf( value, "0" );	
	return( 0 );
	}

/* $nextstub(maxlen) - return next pltab row stub, "" if no more */
else if( strcmp( name, "$nextstub" )==0 ) {
	int maxlen;
	i = 0;
	Egetchunk( val, parms, &i, "," ); /* length */
	maxlen = atoi( val );
	if( maxlen == 0 ) maxlen = 80;

	/* see which axis is using categories or pltab scaling.. */
	Egetunits( 'y', buf );
	strcpy( value, "" );
	if( pltab_in_effect() ) pltab_nextstub( value, maxlen );
	else if( strcmp( buf, "categories" )==0 ) nextcat( 'y', value, maxlen );
	else	{
		Egetunits( 'x', buf );
		if( strcmp( buf, "categories" )==0 ) nextcat( 'x', value, maxlen );
		else Eerr( 2709, "$nextstub only valid with pltab or categories", "" );
		}
	/* convert spaces to underscores */
	for( i = 0; i < strlen( value ); i++ ) if( value[i] == ' ' ) value[i] = '_';
	strcat( value, " " ); /* force to be treated as char */
	/* fprintf( stderr, "[%s]", value );  */
	return( 0 );
	}

/* $fieldname(n) - return the field name assigned to field n.  First is 1 */
else if( strcmp( name, "$fieldname" )==0 ) {
	getfname( atoi( parms ), value );
	return( 0 );
	}

/* $dataitem(row,field) - return the contents of row,field of current data set.
   Row is a number (first = 1).  Field is a datafield (name or number 1..n) */
else if( strcmp( name, "$dataitem" )==0 ) {
	int row, fld;
	i = 0;
	Egetchunk( val, parms, &i, "," ); /* row */
	row = atoi( val ) -1;
	Egetchunk( val, parms, &i, "," ); /* field */
	fld = fref( val ) -1;
	sprintf( value, "%s ", da( row, fld ) );
	return( 0 );
	}

	
return( -1 ); 
}



/* returns field number of specified itemname, or -1 if not found */
custom_specialfieldname( itemname )
char *itemname;
{
return( -1 );
} 


/* returns 0 on success, -1 if named datatype is not found */
custom_datalen( type, lenstr )
char *type, *lenstr;
{
return( -1 );
}
