/* ploticus data display engine.  Software, documentation, and examples.  
 * Copyright 1998-2001 Stephen C. Grubb  (steve@sgpr.net).
 * Covered by GPL; see the file ./Copyright for details. */


/* DRAWFILE - draw commands interpreter.
	The commands follow the structure of the API.

	Does not include any operations in scaled units.


	Add "\n" -> newline conversion to text ops?
*/
#include "graphcore.x"


Eprocess_drawfile( filename )
char *filename;
{
FILE *fp;
char buf[512];
int nt;
char op[80];
double x, y;
int oldtextsize;
char oldcolor[40];
int oldlinetype;
double oldlinewidth, oldpatfact;
char sx[80], sy[80];

if( strlen( filename ) < 0 ) return( 0 );

fp = fopen( filename, "r" );
if( fp == NULL ) return( 0 );
               
oldtextsize = Ecurtextsize;
strcpy( oldcolor, Ecurcolor );
oldlinetype = Ecurlinetype;
oldlinewidth = Ecurlinewidth;
oldpatfact = Ecurpatternfactor;
Etextsize( 12 );
Ecolor( "black" );
Elinetype( 0, 1.0, 1.0 );

while( fgets( buf, 511, fp ) != NULL ) {
	buf[ strlen( buf ) - 1 ] = '\0';

	nt = sscanf( buf, "%s %lf %lf", op, &x, &y );	

	if( nt < 1 ) continue; /* blank line */
	if( op[0] == '/' && op[1] == '/' ) continue; /* comment */

	if( Esmember( op, "mov lin", " " ) && nt != 3 ) { 
		if( nt != 6 ) Eerr( 12002, "Drawfile error", buf );
		continue;
		}

	if( strcmp( op, "mov" )==0 ) Emov( x, y );
	else if( strcmp( op, "lin" )==0 ) Elin( x, y );
	else if( strcmp( op, "text" )==0 ) {
		Econvertnl( &buf[5] );
		Etext( &buf[5] );
		}
	else if( strcmp( op, "path" )==0 ) Epath( x, y );
	else if( strcmp( op, "fill" )==0 ) Efill();
	else if( strcmp( op, "centext" )==0 ) {
		Econvertnl( &buf[8] );
		Ecentext( &buf[8] );
		}
	else if( strcmp( op, "rightjust" )==0 ) {
		Econvertnl( &buf[10] );
		Erightjust( &buf[10] );
		}
	else if( strcmp( op, "cblock" )==0 ) {
		double x1, y1, x2, y2;
		char color[40];
		int outline;
		nt = sscanf( buf, "%*s %lf %lf %lf %lf %s %d",
			&x1, &y1, &x2, &y2, color, &outline );
		if( nt != 6 ) Eerr( 12003, "Drawfile error", buf );
		else Ecblock( x1, y1, x2, y2, color, outline );
		}
	else if( strcmp( op, "color" )==0 ) Ecolor( &buf[6] );
	else if( strcmp( op, "textsize" )==0 ) Etextsize( atoi( &buf[9] ) );
	else if( strcmp( op, "linetype" )==0 ) {
		double z;
		sscanf( buf, "%*s %*s %*s %lf", &z );
		Elinetype( (int)x, y, z );
		}
	else if( strcmp( op, "mark" )==0 ) {
		char sym[80];
		double r;
		sscanf( buf, "%*s %lf %lf %s %lf", &x, &y, sym, &r );
		Emark( x, y, sym, r );
		}
	else if( strcmp( op, "clr" )==0 ) Eclr(); /* allow? */
	else if( strcmp( op, "bkcolor" )==0 ) Ebackcolor( &buf[8] ); /* persist? */
	}
fclose( fp );
Eflush();
/* restore previous settings.. */
Ecolor( oldcolor );
Etextsize( oldtextsize );
Elinetype( oldlinetype, oldlinewidth, oldpatfact );
return( 0 );
}
