/* ploticus data display engine.  Software, documentation, and examples.  
 * Copyright 1998-2001 Stephen C. Grubb  (steve@sgpr.net).
 * Covered by GPL; see the file ./Copyright for details. */


#include "pl.x"
#define MAXNAMES 50

static char fname[MAXNAMES][40];
static int nfname = 0;

/* ============================ */
/* DEFINEFIELDNAMES - define field names from a list 
   (space or comma-delimited) */

definefieldnames( list )
char *list;
{
int i;


nfname = 0;

for( i = 0; i < strlen( list ); i++ ) if( list[i] == ',' ) list[i] = ' ';

i = 0;
while( 1 ) {
	strcpy( fname[ nfname ], Egetok( list, &i ) );
	if( strlen( fname[ nfname ] ) < 1 ) break;
	/* fprintf( stderr, "[%s]", fname[nfname] ); */
	nfname++;
	}
return( 0 );
}

/* ============================ */
/* FREF - given a field name or number, return the field number (1st = 1) */
fref( name )
char *name;
{
int i, fld, prec, stat;

fld = 0;

/* plain number.. */
i = atoi( name );

/* stat added scg 9/26/00 */
stat = Egoodnum( name, &prec );

if( i > 0 && stat ) fld = i; 

/* @number.. */
else if( name[0] == '@' ) {
	stat = Egoodnum( &name[1], &prec );
	i = atoi( &name[1] );
	if( i > 0 && stat ) fld = i;
	}

/* name.. */
else if( nfname > 0 ) {
	for( i = 0; i < nfname; i++ ) {
		if( strcmp( name, fname[i] ) == 0 ) {
			fld = i + 1;
			break;
			}
		}
	}

if( fld < 1 ) {  /* || fld > Nfields[Dsel] -- don't do this because Nfields might not be set yet
			if coming in from getdata select  -scg 10/7/00 */
	Eerr( 2479, "No such data field", name );
	return( 1 ); /* use 1 to be safe; return value is not checked by caller */
	}

return( fld );
}
/* ============================ */
/* GETFNAME - given a field number, return the field name assigned to
	that field (first is 1).
	Return 'noname' if none has been assigned. */

getfname( n, result )
int n;
char *result;
{
if( n > nfname || n < 1 ) strcpy( result, "noname" );
else strcpy( result, fname[ n-1 ] );
return( 0 );
}
