/* ploticus data display engine.  Software, documentation, and examples.  
 * Copyright 1998-2001 Stephen C. Grubb  (steve@sgpr.net).
 * Covered by GPL; see the file ./Copyright for details. */


/* GETDATA - get some data.  Data may be specified literally, or
	gotten from a file or a command.
*/
#include "pl.x"
#define MAXINBUF 3000


static int do_scripter();



getdata( specfile, clonefiles, nclonefiles )
char *specfile, clonefiles[][MAXPATH];
int nclonefiles;
{
int i, j;
FILE *fp;
char buf[MAXINBUF]; /* 2/21/01 */
char attr[40], val[256]; 
char lineval[MAXINBUF]; /* 2/21/01 */
int nt;
FILE *openclonefile();
int icf;

int stat;
int align;
double adjx, adjy;

char datafile[256];
char command[256];
char commentchar[12];
FILE *dfp, *popen();
int gotdata;
int len;
char delim_method[80];
char tok[256];
char scriptname[256];
struct scripterstate ss;
char str[256];
char selectex[256];
int showresults;
int dblen;
int buflen;
int standardinput;
int rotaterec;
int fieldnameheader;
int first;

strcpy( Eprogname, "getdata" );

/* -------------------------- */
/* DEFAULTS */
/* All variables must start out with default values, */
/* since no variable is guaranteed to be set */
/* -------------------------- */
strcpy( Databuf, "" );
strcpy( datafile, "" );
strcpy( command, "" );
strcpy( commentchar, "//" );
strcpy( delim_method, "space" );
gotdata = 0;
strcpy( scriptname, "" );
showresults = 0;
strcpy( selectex, "" );
standardinput = 0;
rotaterec = 0;
strcpy( Bigbuf, "" );
fieldnameheader = 0;

/* -------------------------- */
/* open and process clonefile and specfile */
/* -------------------------- */
for( icf = 0; icf <= nclonefiles; icf++ ) {
 
    if( icf == nclonefiles ) {
        fp = fopen( specfile, "r" );
        if( fp == NULL ) return( Eerr( 117, "Could not open to read", specfile ) );
        }
    else        {
        fp = openclonefile( clonefiles[icf] );
        if( fp == NULL ) continue;
        }


    while( fgets( buf, 255, fp ) != NULL ) {
	nt = sscanf( buf, "%s %s", attr, val );		/* val has 2nd token */
	if( nt < 1 ) continue;
	if( nt == 1 ) strcpy( val, "" );
	if( icf < nclonefiles && stricmp( attr, "#proc" )==0 ) continue;
	i = 0;
        Egetok( buf, &i );
	while( buf[i] == ' ' || buf[i] == '\t' ) i++; /* skip over white space */
        strcpy( lineval, &buf[ i ] ); /* lineval has remainder of line, for sscanf-ing */
        lineval[ strlen( lineval ) - 1 ] = '\0'; /* strip off newline */
 
	/* strip off trailing colon if any.. */
	if( attr[ strlen( attr ) - 1 ] == ':' ) attr[ strlen( attr ) - 1 ] = '\0';

	/* attributes.. */

	if( stricmp( attr, "file" )==0 ) strcpy( datafile, val );

	else if( stricmp( attr, "command" )==0 ) strcpy( command, lineval );

	else if( stricmp( attr, "commentchar" )==0 ) strcpy( commentchar, val );

	else if( strnicmp( attr, "delim", 5 )==0 ) strcpy( delim_method, val );

	else if( stricmp( attr, "data" )==0 ) {
		FILE *tfp;
		sprintf( datafile, "%s_D", Tmpname );
		getmultiline( "data", lineval, fp, MAXBIGBUF, Bigbuf );
		tfp = fopen( datafile, "w" );
		if( tfp == NULL ) return( Eerr( 294, "Cannot open tmp data file", datafile ));
		fprintf( tfp, "%s", Bigbuf );
		fclose( tfp );
		}
	else if( stricmp( attr, "filter" )==0 ) {
		FILE *sfp;
		strcpy( Bigbuf, "" );
		getmultiline( "filter", lineval, fp, MAXBIGBUF, Bigbuf );
		sprintf( scriptname, "%s_S", Tmpname );
		sfp = fopen( scriptname, "w" );
		if( sfp == NULL ) Eerr( 176, "Cannot open tmp file for filter script", scriptname );
		else 	{
			int ix;
			char firsttok[80];
			ix = 0;
			/* convert leading ## to # .. */
			while( 1 ) {
				Egetchunk( buf, Bigbuf, &ix, "\n" );
				if( ix >= strlen( Bigbuf ) ) break;
				sscanf( buf, "%s", firsttok );
				if( firsttok[0] == '#' && firsttok[1] == '#' ) {
					for( i = 0; i < strlen( buf ); i++ ) {
						if( buf[i] == '#' ) break;
						}
					fprintf( sfp, "%s\n", &buf[i+1] );
					}
				else 	{
					fprintf( sfp, "%s\n", buf );
					}
			
				}
			fclose( sfp );
			}
		}

	else if( stricmp( attr, "showresults" )==0 ) {
		if( strnicmp( val, YESANS, 1 )==0 ) showresults = 1;
		else showresults = 0;
		}
	else if( stricmp( attr, "standardinput" )==0 ) {
		if( strnicmp( val, YESANS, 1 )==0 ) standardinput = 1;
		else standardinput = 0;
		}
	else if( stricmp( attr, "rotate" )==0 ) {
		if( strnicmp( val, YESANS, 1 )==0 ) rotaterec = 1;
		else rotaterec = 0;
		}
	else if( stricmp( attr, "select" )==0 ) {
		strcpy( selectex, lineval );
		}
	else if( stricmp( attr, "fieldnames" )==0 ) {
		definefieldnames( lineval );
		}
	else if( stricmp( attr, "fieldnameheader" )==0 ) {
		if( strnicmp( val, YESANS, 1 )==0 ) fieldnameheader = 1;
		else fieldnameheader = 0;
		}

	else Eerr( 1, "attribute not recognized", attr );
	}
    fclose( fp );
    }

/* -------------------------- */
/* now do the work.. */
/* -------------------------- */


/* if( showresults ) fprintf( Diagfp, "// Note: getdata debug output:\n" ); */

if( !slmember( delim_method, "s* c* t*" )) {
	Eerr( 5839, "Warning, invalid delim specification, using 'space'", delim_method );
	strcpy( delim_method, "space" );
	}
	
if( standardinput || strcmp( datafile, "-" ) ==0 ) { /* a file of "-" means read from stdin */
	dfp = stdin;
	goto PT1;
	}
if( strlen( datafile ) > 0 ) sprintf( command, "cat %s", datafile );
if( strlen( command ) > 0 ) {
	dfp = popen( command, "r" );
	if( dfp == NULL ) {
		Skipout = 1;
		return( Eerr( 401, "Cannot open", command ) );
		}

	PT1:
	strcpy( Databuf, "" );
	len = 0;
	gotdata = 1;
	first = 1;
	while( fgets( buf, MAXINBUF-1, dfp ) != NULL ) { 
		nt = sscanf( buf, "%s", tok );
		if( nt < 1 ) continue;
		if( strncmp( tok, commentchar, strlen( commentchar ) )==0 ) continue;


		/* #set var = value  - added scg 11/13/00 */
		if( strcmp( tok, "#set" )==0 ) {
			int ix, oldix;
			char varname[40];
			ix = 0;
			getchunk( tok, buf, &ix, " 	" ); /* #set */
			getchunk( varname, buf, &ix, " 	=" ); /* varname */
			declarevar( varname );
			oldix = ix;
			getchunk( tok, buf, &ix, " 	" ); /* optional = */
			if( strcmp( tok, "=" ) != 0 ) ix = oldix;
			if( buf[ix+1] == '"' ) setvar( varname, &buf[ix+2] );
			else setvar( varname, &buf[ix+1] );
			continue;
			}

		/* field name header.. */
		if( first && fieldnameheader ) {
			definefieldnames( buf );
			first = 0;
			continue;
			}


		/* select */
		if( strlen( selectex ) > 0 ) { 
			stat = do_scripter( buf, selectex, delim_method, 1 ); /*doesn't modify buf*/
			if( ! stat ) continue;
			/* 
			 * buflen = strlen( buf )-1;
			 * if( buf[ buflen ] != '\n' ) strcpy( &buf[buflen], "\n" );
			 */
			/* if( showresults ) fprintf( Diagfp, "%s", buf ); */
			}

		/* optional scripter data processing.. */
                if( strlen( scriptname ) > 0 ) {
                        do_scripter( buf, scriptname, delim_method, 0 ); /* modifies buf */
                        getvar( "_PRINTDATA", str );
                        if( strcmp( str, "0" )== 0 ) continue; /* user is supressing print of data*/
			if( buf[ strlen( buf ) -1 ] != '\n' ) strcat( buf, "\n" ); /* strcat ok */
			/* if( showresults ) fprintf( Diagfp, "%s", buf ); */
                        }

		dblen = len;
		len += strlen( buf );
		if( len >= MAXDATABUF ) {
			/* this is pretty much fatal.. */
			Skipout = 1;
			return( Eerr( 406, "Sorry, data set too large, capacity exceeded.", "" ) );
			}
		strcpy( &Databuf[dblen], buf );
		}
	}

if( smember( datafile, "- stdin STDIN" )); /* don't want to close STDIN */
else pclose( dfp );

/* set a clean slate.. */
Dsize = strlen( Databuf ); 
Dsel = 0;
 
ND[0] = 0; ND[1] = 0;
Nrecords[0] = 0; Nrecords[1] = 0;
Nfields[0] = 0; Nfields[1] = 0;
StartD[0] = 0; StartD[1] = 0;


if( !gotdata ) {
	Skipout = 1;
	return( Eerr( 407, "No data, file, or command was specified", "" ) );
	}


/* parse data and always put in D beginning at position 0.. */
/* parsedata( Databuf, delim_method, commentchar ); */

/* was just: Databuf */
stat = parsedata( Databuf, delim_method, commentchar, D, MAXD, 
	&Nrecords[Dsel], &Nfields[Dsel], &ND[Dsel] );

 

setintvar( "NRECORDS", Nrecords[Dsel] );
setintvar( "NFIELDS", Nfields[Dsel] );

if( stat != 0 ) {
	/* this is pretty much fatal.. */
	Skipout = 1; 
	return( Eerr( stat, "Parsing error on input data.", "" ));
	}

if( ND[Dsel] < 1 ) {
	/* Skipout = 1; */  /* trying this.. scg 11/24/00 */
	setintvar( "NRECORDS", 0 );
	return( Eerr( 408, "No data were read", "" ) );
	}

if( Debug ) fprintf( Diagfp, "// getdata has read %d records with %d fields per record.\n", 
	Nrecords[Dsel], Nfields[Dsel] );

if( showresults ) {
	fprintf( Diagfp, "// Data rows and fields (square brackets added):\n" );
 	for( i = 0; i < Nrecords[Dsel]; i++ ) {
 		for( j = 0; j < Nfields[Dsel]; j++ ) fprintf( Diagfp, "[%s]", da(i,j) );
		fprintf( Diagfp, "\n" );
 		}
	}


if( rotaterec ) {   /* swap nrecords and nfields */
	int tmp;
	if( Nrecords[Dsel] != 1 ) Eerr( 5798, "rotate cannot be done if more than 1 row of data", "" );
	else	{
		tmp = Nrecords[Dsel];
		Nrecords[Dsel] = Nfields[Dsel];
		Nfields[Dsel] = tmp;
		}
	}

return( 0 );
}
/* ======================================== */

static int
do_scripter( buf, scriptname, delim, mode )
char *buf;
char *scriptname;
char *delim;
int mode; /* 0 = scripter    1 = condex */
{
int stat;
char recordid[80]; 
char data[MAXITEMS][DATAMAXLEN+1];
char *df[MAXITEMS];
char str[255], str2[255];
int nfields, nrecords, nd;
int i;
char commentchar[12];
struct scripterstate ss;
int buflen;

strcpy( recordid, "" ); /* not used */
strcpy( commentchar, "//" ); /* not used? */

/* split up buf into fields.. */
strcpy( str, buf );
parsedata( str, delim, commentchar, df, MAXITEMS, &nrecords, &nfields, &nd ); 

if( mode == 1 ) { /* condex processing.. */
	strcpy( str2, str );
	stat = plvalue_subst( str2, scriptname, df, FOR_CONDEX );
	if( stat > 1 ) Eerr( 2208, "value_subst error", scriptname );
	stat = condex( str2 );
	return( stat );
		

#ifdef CUT
	Why does the following need to be done?
	WAS: else {
		strcpy( buf, "" );
		buflen = 0;
		for( i = 0; i < nfields; i++ ) {
			sprintf( str, "\"%s\" ", df[i] );
			/* strcat( buf, str ); */
			strcpy( &buf[buflen], str );
			buflen += strlen( str );
			}
		return( 0 );
		}
#endif
	}

/* for scripter we need to copy data into array.. */
for( i = 0; i < MAXITEMS; i++ ) strcpy( data[i], "" ); /* null out entire data array.. added scg 11/15/00 */
for( i = 0; i < nfields; i++ ) strcpy( data[i], df[i] );

if( strlen( scriptname ) > 0 ) {
	stat = scripter_open( &ss, scriptname );
	if( stat != 0 ) {
		Eerr( stat, "cannot open filter script for reading", scriptname );
		strcpy( scriptname, "" );
		}
	}

/* do filter processing.. */
declarevar( "_PRINTDATA" );
setvar( "_PRINTDATA", "" );
strcpy( buf, "" );
while( 1 ) {
	stat = scripter( &ss, str, recordid, data );
        if( stat > 255 ) {
		scripter_close( &ss );
		return( Eerr( 169, "filter script error.. quitting..", "" ) );
		}
        else if( stat != 0 ) break;
	strcat( buf, str ); /* strcat ok */
	}
scripter_close( &ss );
getvar( "_PRINTDATA", str );
if( strcmp( str, "" )== 0 ) return( 0 ); /* don't print data; return scripter results in buf */

/* if user opted to "print data", assemble fields back into one string.. */
strcpy( buf, "" );
for( i = 0; i < nfields; i++ ) {
	sprintf( str, "\"%s\" ", data[i] );
	strcat( buf, str );
	}
return( 0 );
}

