/* ploticus data display engine.  Software, documentation, and examples.  
 * Copyright 1998-2001 Stephen C. Grubb  (steve@sgpr.net).
 * Covered by GPL; see the file ./Copyright for details. */


#include "graphcore.d"

FILE *Errfp;

/* overall settings - these can be set by application program before Einit() */
char Estandard_font[60] = "/Helvetica";  /* default font */
int Estandard_textsize = 10;	 /* standard text size, relative to 10 pt. */
double Estandard_lwscale = 1.0;		 /* scaling factor for line width */
char Estandard_color[30] = "black" ;	 /* default drawing/text color */
char Estandard_bkcolor[30] = "white";	 /* default background color */

/* window size.. */
double EWinx, EWiny;
/* original window size.. */
double EWinx_0, EWiny_0;

/* basic device */
char Edev;

int  Epixelsinch;  /* number of pixels/inch */

/* current parameters.. */
char Ecurfont[60] = "";
int Ecurtextsize = 0;
double Ecurtextheight = 0.0;
double Ecurtextwidth = 0.0;
int Ecurtextdirection = 0;
int Ecurpaper = -1;
double Ecurlinewidth = -1.0;
int Ecurlinetype = -1;
double Ecurpatternfactor = 0.0;
char Ecurcolor[30]; /* current color for lines, text, shading */
char Ecurbkcolor[30]; /* current color for background (when screen clears) */
char Ecurhilitedraw[30]; /* current color for lines, text, shading in highlighted areas */
char Ecurhilitebk[30];  /* current color for background of highlighted areas */


/* event information */
int EEvent;
double EEventx, EEventy;

/* scaling.. */
double EXlo, EXhi, EYlo, EYhi;		/* graphic area bounds, absolute coords */
double EDXlo, EDXhi, EDYlo, EDYhi;		/* graphic area bounds, data coords */
double EScale_x = 1, EScale_y = 1; 		/* linear scaling factors in x and y */
int Escaletype_x = E_LINEAR;	/* either LINEAR or LOG */
int Escaletype_y = E_LINEAR;	/* either LINEAR or LOG */


double Ex1, Ey1; /* last moveto */
double Ex2, Ey2; /* last lineto */


char Eprogname[40] = ""; /* program name, used in error messages. */

int Eflip = 0;  /* if 1, reverse x and y, for doing sideways variations */

int Eblacklines = 0; /* if 1, and device is a b/w device, make non-white lines black unconditionally */

long Eflashdelay = 150000; /* flashpick delay in microseconds */

