/* ploticus data display engine.  Software, documentation, and examples.  
 * Copyright 1998-2001 Stephen C. Grubb  (steve@sgpr.net).
 * Covered by GPL; see the file ./Copyright for details. */


#include "pl.x"

import( specfile, clonefiles, nclonefiles  )
char *specfile, clonefiles[][ MAXPATH ];
int nclonefiles;
{
int i;
FILE *fp;
char buf[256];
char attr[40], val[256];
char lineval[256];
int nt;
FILE *openclonefile();
int icf;

int stat;
int align;
double adjx, adjy;

char format[20];
char filename[256];
double x, y;
char imalign[30];
double scalex, scaley;

strcpy( Eprogname, "pl proc import" );
/* -------------------------- */
/* DEFAULTS */
/* All variables must start out with default values, */
/* since no variable is guaranteed to be set */
/* -------------------------- */
strcpy( format, "png" );
strcpy( filename, "" );
x = 3.0;
y = 3.0;
strcpy( imalign, "centered" );
scalex = 1.0;
scaley = 1.0;

/* -------------------------- */
/* open and process all clonefiles and lastly, specfile */
/* -------------------------- */
for( icf = 0; icf <= nclonefiles; icf++ ) {
 
    if( icf == nclonefiles ) {
        fp = fopen( specfile, "r" );
        if( fp == NULL ) return( Eerr( 117, "Could not open to read", specfile ) );
        }
    else        {
        fp = openclonefile( clonefiles[icf] );
        if( fp == NULL ) continue;
        }

    while( fgets( buf, 255, fp ) != NULL ) {
	nt = sscanf( buf, "%s %s", attr, val );		/* val has 2nd token */
	if( nt < 1 ) continue;
	if( nt == 1 ) strcpy( val, "" );
	if( icf < nclonefiles && stricmp( attr, "#proc" )==0 ) continue;
	i = 0;
        Egetok( buf, &i );
	while( buf[i] == ' ' || buf[i] == '\t' ) i++; /* skip over white space */
        strcpy( lineval, &buf[ i ] ); /* lineval has remainder of line, for sscanf-ing */
        lineval[ strlen( lineval ) - 1 ] = '\0'; /* strip off newline */
 
	/* strip off trailing colon if any.. */
	if( attr[ strlen( attr ) - 1 ] == ':' ) attr[ strlen( attr ) - 1 ] = '\0';


	/* attributes.. */

	if( stricmp( attr, "format" )==0 ) strcpy( format, val );
	else if( strnicmp( attr, "file", 4 )==0 ) strcpy( filename, val );
	else if( stricmp( attr, "align" )==0 ) strcpy( imalign, val );
	else if( stricmp( attr, "scale" )==0 ) {
		nt = sscanf( lineval, "%lf %lf", &scalex, &scaley );
		if( nt == 1 ) scaley = scalex;
		}
	else if( stricmp( attr, "location" )==0 ) {
		if( strlen( lineval ) > 0 ) getcoords( "location", lineval, &x, &y );
		}
               

	else Eerr( 1, "attribute not recognized", attr );
	}
    fclose( fp );
    }

/* -------------------------- */
/* overrides and degenerate cases */
/* -------------------------- */


/* -------------------------- */
/* now do the plotting work.. */
/* -------------------------- */
#ifdef CUTSCG
if( tolower(format[0]) == 'g' ) {   /* GIF */
	if( !devavail( "g" ) )
	  return( Eerr( 4891, "Cannot import gif - gif not available in this build", "" ) );
	if( Device != 'g' || Png )
	  return( Eerr( 4892, "Must use -gif to be able to import a gif file", "" ) );
	stat = Eimload( filename, scalex, scaley );
	if( stat != 0 ) return( Eerr( 5892, "Error on image load", filename ) );

	stat = Eimplace( x, y, imalign, 1.0, 1.0 );
	}
#endif
if( stricmp( format, "png" )==0  ) {   /* PNG */
	if( !devavail( "png" ) )
	  return( Eerr( 4891, "Cannot import png- png not available in this build", "" ) );
	if( !Png )
	  return( Eerr( 4892, "Must use -png to be able to import a png file", "" ) );
	stat = Eimload( filename, scalex, scaley );
	if( stat != 0 ) return( Eerr( 5893, "Error on image load", filename ) );

	stat = Eimplace( x, y, imalign, 1.0, 1.0 );
	}
else	return( Eerr( 2804, "No import is available for this type", format ));

return( 0 );
}
