/* ploticus data display engine.  Software, documentation, and examples.  
 * Copyright 1998-2001 Stephen C. Grubb  (steve@sgpr.net).
 * Covered by GPL; see the file ./Copyright for details. */


/* Define one legend entry */
#include "pl.x"

legendentry( specfile, clonefiles, nclonefiles  )
char *specfile, clonefiles[][ MAXPATH ];
int nclonefiles;
{
int i;
FILE *fp;
char buf[256];
char attr[40], val[256];
char lineval[256];
int nt;
FILE *openclonefile();
int icf;

int stat;
int align;
double adjx, adjy;

char label[120];
char sampletype[80];
char spec1[120];
char spec2[120];
char spec3[120];
int  samptyp;

strcpy( Eprogname, "pl proc legendentry" );
/* -------------------------- */
/* DEFAULTS */
/* All variables must start out with default values, */
/* since no variable is guaranteed to be set */
/* -------------------------- */
strcpy( label, "" );
strcpy( sampletype, "none" );
strcpy( spec1, "" );
strcpy( spec2, "" );
strcpy( spec3, "" );

/* -------------------------- */
/* open and process all clonefiles and lastly, specfile */
/* -------------------------- */
for( icf = 0; icf <= nclonefiles; icf++ ) {
 
    if( icf == nclonefiles ) {
        fp = fopen( specfile, "r" );
        if( fp == NULL ) return( Eerr( 117, "Could not open to read", specfile ) );
        }
    else        {
        fp = openclonefile( clonefiles[icf] );
        if( fp == NULL ) continue;
        }

    while( fgets( buf, 255, fp ) != NULL ) {
	nt = sscanf( buf, "%s %s", attr, val );		/* val has 2nd token */
	if( nt < 1 ) continue;
	if( nt == 1 ) strcpy( val, "" );
	if( icf < nclonefiles && stricmp( attr, "#proc" )==0 ) continue;
	i = 0;
        Egetok( buf, &i );
	while( buf[i] == ' ' || buf[i] == '\t' ) i++; /* skip over white space */
        strcpy( lineval, &buf[ i ] ); /* lineval has remainder of line, for sscanf-ing */
        lineval[ strlen( lineval ) - 1 ] = '\0'; /* strip off newline */
 
	/* strip off trailing colon if any.. */
	if( attr[ strlen( attr ) - 1 ] == ':' ) attr[ strlen( attr ) - 1 ] = '\0';


	/* attributes.. */

	if( stricmp( attr, "label" )==0 ) strcpy( label, lineval );
	else if( stricmp( attr, "sampletype" )==0 ) strcpy( sampletype, val );
	else if( stricmp( attr, "details" )==0 ) strcpy( spec1, lineval );
	else if( stricmp( attr, "details2" )==0 ) strcpy( spec2, lineval );
	else if( stricmp( attr, "details3" )==0 ) strcpy( spec3, lineval );

	else Eerr( 1, "attribute not recognized", attr );
	}
    fclose( fp );
    }

/* -------------------------- */
/* overrides and degenerate cases */
/* -------------------------- */


/* -------------------------- */
/* now do the plotting work.. */
/* -------------------------- */

if( stricmp( sampletype, "line" )==0 ) samptyp = LEGEND_LINE;
else if( stricmp( sampletype, "color" )==0 ) samptyp = LEGEND_COLOR;
else if( stricmp( sampletype, "symbol" )==0 ) samptyp = LEGEND_SYMBOL;
else if( stricmp( sampletype, "text" )==0 ) samptyp = LEGEND_TEXT;
else if( stricmp( sampletype, "line+symbol" )==0 ) samptyp = LEGEND_LINE + LEGEND_SYMBOL;
else if( stricmp( sampletype, "text+symbol" )==0 ) samptyp = LEGEND_TEXT + LEGEND_SYMBOL;
else if( stricmp( sampletype, "none" )==0 ) samptyp = 0;

add_legent( samptyp, label, spec1, spec2, spec3 );

return( 0 );
}
