/* ploticus data display engine.  Software, documentation, and examples.  
 * Copyright 1998-2001 Stephen C. Grubb  (steve@sgpr.net).
 * Covered by GPL; see the file ./Copyright for details. */


/* LINE - draw arbitrary line(s) */
#include "pl.x"

line( specfile, clonefiles, nclonefiles )
char *specfile, clonefiles[][ MAXPATH ];
int nclonefiles;
{
int i;
FILE *fp;
char buf[256];
char attr[40], val[256];
char lineval[256];
int nt;
FILE *openclonefile();
int icf;

int stat;
int align;
double adjx, adjy;
double x, y;
char linedetails[256];
char notation[80];
char a[40], b[40], c[40], d[40];
int ix;
int first;


strcpy( Eprogname, "pl proc line" );
/* -------------------------- */
/* DEFAULTS */
/* All variables must start out with default values, */
/* since no variable is guaranteed to be set */
/* -------------------------- */
strcpy( Bigbuf, "" );
strcpy( linedetails, "" );
strcpy( notation, "locvalue" );
x = 0.0;
y = 0.0;

/* -------------------------- */
/* open and process all clonefiles and lastly, specfile */
/* -------------------------- */
for( icf = 0; icf <= nclonefiles; icf++ ) {
 
    if( icf == nclonefiles ) {
        fp = fopen( specfile, "r" );
        if( fp == NULL ) return( Eerr( 117, "Could not open to read", specfile ) );
        }
    else        {
        fp = openclonefile( clonefiles[icf] );
        if( fp == NULL ) continue;
        }


    while( fgets( buf, 255, fp ) != NULL ) {
	nt = sscanf( buf, "%s %s", attr, val );		/* val has 2nd token */
	if( nt < 1 ) continue;
	if( nt == 1 ) strcpy( val, "" );
	if( icf < nclonefiles && stricmp( attr, "#proc" )==0 ) continue;
	i = 0;
        Egetok( buf, &i );
	while( buf[i] == ' ' || buf[i] == '\t' ) i++; /* skip over white space */
        strcpy( lineval, &buf[ i ] ); /* lineval has remainder of line, for sscanf-ing */
        lineval[ strlen( lineval ) - 1 ] = '\0'; /* strip off newline */
 
	/* strip off trailing colon if any.. */
	if( attr[ strlen( attr ) - 1 ] == ':' ) attr[ strlen( attr ) - 1 ] = '\0';


	/* attributes.. */

	if( stricmp( attr, "points" )==0 ) 
		getmultiline( "points", lineval, fp, MAXBIGBUF, Bigbuf );

	else if( stricmp( attr, "linedetails" )==0 ) strcpy( linedetails, lineval );
	else if( stricmp( attr, "notation" )==0 ) strcpy( notation, val );

	else if( stricmp( attr, "saveas" )==0 ) {
		if( icf == nclonefiles ) saveas( specfile, val );
		}
	else Eerr( 1, "attribute not recognized", attr );
	}
    fclose( fp );
    }


/* -------------------------- */
/* overrides and degenerate cases */
/* -------------------------- */



/* -------------------------- */
/* now do the plotting work.. */
/* -------------------------- */
linedet( "linedetails", linedetails, 1.0 );
if( !Emember( notation[0], "aAsSlL" )) {
	strcpy( notation, "a" );
	Eerr( 479, "notation must be one of: absolute scaled locval", notation );
	}
ix = 0;
first = 1;
while( 1 ) {
	Egetchunk( buf, Bigbuf, &ix, "\n" );
	nt = sscanf( buf, "%s %s %s %s", a, b, c, d );

	if( nt == 4 || first ) { 
		if( notation[0] == 'a' ) { 
			Emov( atof( a ), atof( b ) ); 
			/* if( !first ) */ Elin( atof( c ), atof( d ) ); 
			}
		else if( notation[0] == 's' ) { 
			Emov( Eu( X, a ), Eu( Y, b ) ); 
			if( Econv_error() ) Eerr( 2945, "unplottable value(s) ", buf );
			/* if( !first ) { */
				Elin( Eu( X, c ), Eu( Y, d ) ); 
				if( Econv_error() ) Eerr( 2946, "unplottable value(s) ", buf );
			/* } */
			}
		else if( notation[0] == 'l' ) { 
			Eposex( a, X, &x ); Eposex( b, Y, &y ); Emov( x, y );
			if( Econv_error() ) Eerr( 2947, "unplottable value(s) ", buf );
			/* if( !first ) { */
				Eposex( c, X, &x ); Eposex( d, Y, &y ); Elin( x, y );
				if( Econv_error() ) Eerr( 2948, "unplottable value(s) ", buf );
			/* 	} */
			}
		}

	else if( nt == 2 ) { 
		if( notation[0] == 'a' ) Elin( atof( a ), atof( b ) ); 
		else if( notation[0] == 's' ) Elin( Eu( X, a ), Eu( Y, b ) ); 
		else if( notation[0] == 'l' ) { 
			Eposex( a, X, &x ); Eposex( b, Y, &y ); Elin( x, y );
			}
		}
	else if( nt <= 0 ) ;
	else Eerr( 2959, "warning: points must have either 4 or 2 values per line", "" );

	first = 0;

	if( ix >= strlen( Bigbuf ) ) break;
	}
return( 0 );
}
